
CoCoALib - Feature #233

AsINT and AsRAT  -- ConvertTo<BigInt> and ConvertTo<BigRat>

25 Sep 2012 16:32 - John Abbott

Status: Closed Start date: 25 Sep 2012

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 2.00 hours

Target version: CoCoALib-0.99532 Spent time: 2.00 hours

Description

Should we implement functions very like AsINT and AsRAT in CoCoALib?

What should their names be?  Anna suggests AsBigInt and AsBigRat?

If so, design them properly!

Anna also points out that AsPolyRing and other similarly named functions for rings are essentially costless casts whereas AsBigInt

is a costly operation.

2014-01: Final decision is for ConvertTo<BigInt>, ConvertTo<BigRat>

Related issues:

Related to CoCoALib - Feature #253: W.Bruns's wish list Closed 04 Oct 2012

Related to CoCoA-5 - Design #301: How to obtain an integer from a finite fiel... Closed 08 Feb 2013

Related to CoCoA - Support #425: Osnabrueck 2014-01 Closed 27 Jan 2014

Related to CoCoALib - Feature #426: ConvertTo with optional arg to give more ... Closed 27 Jan 2014

Related to CoCoALib - Feature #61: Conversion functions -- documentation Closed 13 Dec 2011

History

#1 - 04 Oct 2012 12:22 - John Abbott

- Status changed from New to In Progress

JAA suggests using the convert family for achieving this.  For instance

  RingElem x(...);

  BigInt N = ConvertTo<BigInt>(x);

  BigRat Q = ConvertTo<BigRat>(x);

 

2013-01-30 JAA has made experimental impl of ConvertTo<BigInt> for RingElem.

#2 - 05 Oct 2012 18:07 - John Abbott

If I define ConvertTo for converting RingElem into BigInt, should I define all members of the convert family for performing the conversions?  This might

make IsInteger redundant...

#3 - 28 Jan 2013 08:07 - Anna Maria Bigatti

- Category set to New Function
#4 - 20 Nov 2013 19:58 - John Abbott

An advantage of Anna's suggested names is that they are more compact than using the ConvertTo template fn.

JAA suggests looking through CoCoALib source code (and examples?) to see how IsInteger is used.

PS it'd be nice to close this task soon; it's little more than just a naming issue.

#5 - 28 Jan 2014 14:48 - Anna Maria Bigatti

- Status changed from In Progress to Feedback

- Assignee set to John Abbott

- Target version set to CoCoALib-0.9953

- % Done changed from 0 to 80

Final decision is for ConvertTo<BigInt> and ConvertTo<BigRat>

#6 - 21 Mar 2014 14:28 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.9953 to CoCoALib-0.99532

#7 - 01 Apr 2014 18:59 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 80 to 100

- Estimated time set to 2.00 h

Please note that ConvertTo<..>(N)

also allows passing an error message

ConvertTo<long>(NumIndets, ErrMesg)

<\pre>

#8 - 02 Apr 2014 09:19 - Anna Maria Bigatti

- Subject changed from AsINT and AsRAT to AsINT and AsRAT  -- ConvertTo<BigInt> and ConvertTo<BigRat>
